diff --git a/tests/test_hub/test_add_archivetype.py b/tests/test_hub/test_add_archivetype.py
index 49cd35a..fabeab3 100644
--- a/tests/test_hub/test_add_archivetype.py
+++ b/tests/test_hub/test_add_archivetype.py
@@ -10,54 +10,74 @@ IP = kojihub.InsertProcessor
 
 class TestAddArchiveType(unittest.TestCase):
 
-    @mock.patch('kojihub.verify_name_internal')
-    @mock.patch('kojihub._multiRow')
-    @mock.patch('kojihub.get_archive_type')
-    @mock.patch('kojihub.InsertProcessor')
-    def test_add_archive_type(self, InsertProcessor, get_archive_type, _multiRow,
-                              verify_name_internal):
-        # Not sure why mock can't patch kojihub.context, so we do this
-        session = kojihub.context.session = mock.MagicMock()
-        mocks = [InsertProcessor, get_archive_type, session]
-        # It seems MagicMock will not automatically handle attributes that
-        # start with "assert"
-        session.assertPerm = mock.MagicMock()
-        verify_name_internal.return_value = None
-
-        # expected case
-        get_archive_type.return_value = None
-        insert = InsertProcessor.return_value
+    def setUp(self):
+
+        self.context = mock.patch('kojihub.context').start()
+        self.context.session.assertPerm = mock.MagicMock()
+        self.exports = kojihub.RootExports()
+        self.channel_name = 'test-channel'
+        self.description = 'test-description'
+        self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
+                                          side_effect=self.getInsert).start()
+        self.inserts = []
+        self.insert_execute = mock.MagicMock()
+        self.verify_name_internal = mock.patch('kojihub.verify_name_internal').start()
+        self.get_archive_type = mock.patch('kojihub.get_archive_type').start()
+        self._multiRow = mock.patch('kojihub._multiRow').start()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def getInsert(self, *args, **kwargs):
+        insert = IP(*args, **kwargs)
+        insert.execute = self.insert_execute
+        self.inserts.append(insert)
+        return insert
+
+    def test_add_archive_type_valid(self):
+        self.verify_name_internal.return_value = None
+        self.get_archive_type.return_value = None
         kojihub.add_archive_type('deb', 'Debian package', 'deb')
-        InsertProcessor.assert_called_once()
-        insert.execute.assert_called_once()
-
-        args, kwargs = InsertProcessor.call_args
-        ip = IP(*args, **kwargs)
-        self.assertEqual(ip.table, 'archivetypes')
-        self.assertEqual(ip.data, {'name': 'deb',
-                                   'description': 'Debian package',
-                                   'extensions': 'deb'})
-        self.assertEqual(ip.rawdata, {})
-        session.assertPerm.assert_called_with('admin')
-
-        for m in mocks:
-            m.reset_mock()
-        session.assertPerm = mock.MagicMock()
-
-        # already exists
-        get_archive_type.return_value = True
+
+        self.assertEqual(len(self.inserts), 1)
+        insert = self.inserts[0]
+        self.assertEqual(insert.table, 'archivetypes')
+        self.assertEqual(insert.data, {'name': 'deb',
+                                       'description': 'Debian package',
+                                       'extensions': 'deb'})
+        self.assertEqual(insert.rawdata, {})
+        self.context.session.assertPerm.assert_called_with('admin')
+
+    def test_add_archive_type_already_exists(self):
+        self.get_archive_type.return_value = True
         with self.assertRaises(koji.GenericError):
             kojihub.add_archive_type('deb', 'Debian package', 'deb')
-        InsertProcessor.assert_not_called()
-        session.assertPerm.assert_called_with('admin')
+        self.assertEqual(len(self.inserts), 0)
+        self.context.session.assertPerm.assert_called_with('admin')
+
+    def test_add_archive_type_invalid_value_type(self):
+        self.verify_name_internal.return_value = None
+        description = ['Debian package']
+        with self.assertRaises(koji.ParameterError) as ex:
+            kojihub.add_archive_type('deb', description, 'deb')
+        self.assertEqual(f"Invalid type for value '{description}': {type(description)}",
+                         str(ex.exception))
+
+    def test_add_archive_type_invalid_value_extensions(self):
+        extensions = ['deb']
+        with self.assertRaises(koji.ParameterError) as ex:
+            kojihub.add_archive_type('deb', 'Debian package', extensions)
+        self.assertEqual(f"Invalid type for value '{extensions}': {type(extensions)}",
+                         str(ex.exception))
 
+    def test_add_archive_type_wrong_name_verify(self):
         # name is longer as expected
         new_archive_type = 'new-archive-type+'
-        verify_name_internal.side_effect = koji.GenericError
+        self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             kojihub.add_archive_type(new_archive_type, 'Debian package', 'deb')
 
         # not except regex rules
-        verify_name_internal.side_effect = koji.GenericError
+        self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             kojihub.add_archive_type(new_archive_type, 'Debian package', 'deb')
diff --git a/tests/test_hub/test_add_channel.py b/tests/test_hub/test_add_channel.py
index 5588c7b..a2506c6 100644
--- a/tests/test_hub/test_add_channel.py
+++ b/tests/test_hub/test_add_channel.py
@@ -22,6 +22,9 @@ class TestAddChannel(unittest.TestCase):
                                           side_effect=self.getInsert).start()
         self.inserts = []
         self.insert_execute = mock.MagicMock()
+        self.verify_name_internal = mock.patch('kojihub.verify_name_internal').start()
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self._singleValue = mock.patch('kojihub._singleValue').start()
 
     def tearDown(self):
         mock.patch.stopall()
@@ -32,25 +35,19 @@ class TestAddChannel(unittest.TestCase):
         self.inserts.append(insert)
         return insert
 
-    @mock.patch('kojihub.verify_name_internal')
-    @mock.patch('kojihub.get_channel')
-    @mock.patch('kojihub._singleValue')
-    def test_add_channel_exists(self, _singleValue, get_channel, verify_name_internal):
-        verify_name_internal.return_value = None
-        get_channel.return_value = {'id': 123, 'name': self.channel_name}
+    def test_add_channel_exists(self):
+        self.verify_name_internal.return_value = None
+        self.get_channel.return_value = {'id': 123, 'name': self.channel_name}
         with self.assertRaises(koji.GenericError):
             self.exports.addChannel(self.channel_name)
-        get_channel.assert_called_once_with(self.channel_name, strict=False)
-        _singleValue.assert_not_called()
+        self.get_channel.assert_called_once_with(self.channel_name, strict=False)
+        self._singleValue.assert_not_called()
         self.assertEqual(len(self.inserts), 0)
 
-    @mock.patch('kojihub.verify_name_internal')
-    @mock.patch('kojihub.get_channel')
-    @mock.patch('kojihub._singleValue')
-    def test_add_channel_valid(self, _singleValue, get_channel, verify_name_internal):
-        get_channel.return_value = {}
-        _singleValue.side_effect = [12]
-        verify_name_internal.return_value = None
+    def test_add_channel_valid(self):
+        self.get_channel.return_value = {}
+        self._singleValue.side_effect = [12]
+        self.verify_name_internal.return_value = None
 
         r = self.exports.addChannel(self.channel_name, description=self.description)
         self.assertEqual(r, 12)
@@ -62,21 +59,20 @@ class TestAddChannel(unittest.TestCase):
         self.assertEqual(insert.table, 'channels')
 
         self.context.session.assertPerm.assert_called_once_with('admin')
-        get_channel.assert_called_once_with(self.channel_name, strict=False)
-        self.assertEqual(_singleValue.call_count, 1)
-        _singleValue.assert_has_calls([
+        self.get_channel.assert_called_once_with(self.channel_name, strict=False)
+        self.assertEqual(self._singleValue.call_count, 1)
+        self._singleValue.assert_has_calls([
             mock.call("SELECT nextval('channels_id_seq')", strict=True)
         ])
 
-    @mock.patch('kojihub.verify_name_internal')
-    def test_add_channel_wrong_format(self, verify_name_internal):
+    def test_add_channel_wrong_name(self):
         # name is longer as expected
         channel_name = 'test-channel+'
-        verify_name_internal.side_effect = koji.GenericError
+        self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             self.exports.addChannel(channel_name)
 
         # not except regex rules
-        verify_name_internal.side_effect = koji.GenericError
+        self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             self.exports.addChannel(channel_name)
diff --git a/tests/test_hub/test_add_external_repo_to_tag.py b/tests/test_hub/test_add_external_repo_to_tag.py
index 0a47b36..189516e 100644
--- a/tests/test_hub/test_add_external_repo_to_tag.py
+++ b/tests/test_hub/test_add_external_repo_to_tag.py
@@ -1,4 +1,5 @@
 import unittest
+import mock
 
 import koji
 import kojihub
@@ -6,8 +7,26 @@ import kojihub
 
 class TestAddExternalRepoToTag(unittest.TestCase):
 
+    def setUp(self):
+        self.tag_name = 'test-tag'
+        self.get_tag = mock.patch('kojihub.get_tag').start()
+        self.get_external_repo = mock.patch('kojihub.get_external_repo').start()
+        self.tag_info = {'id': 1, 'name': self.tag_name}
+
+    def tearDown(self):
+        mock.patch.stopall()
+
     def test_with_wrong_merge_mode(self):
         merge_mode = 'test-mode'
         with self.assertRaises(koji.GenericError) as cm:
-            kojihub.add_external_repo_to_tag('tag', 'repo', 1, merge_mode=merge_mode)
-        self.assertEqual('No such merge mode: %s' % merge_mode, str(cm.exception))
+            kojihub.add_external_repo_to_tag(self.tag_name, 'repo', 1, merge_mode=merge_mode)
+        self.assertEqual(f"No such merge mode: {merge_mode}", str(cm.exception))
+
+    def test_priority_not_int(self):
+        priority = 'test-priority'
+        self.get_tag.return_value = self.tag_info
+        self.get_external_repo.return_value = {'id': 123}
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.add_external_repo_to_tag(self.tag_name, 'repo', priority, merge_mode=None)
+        self.assertEqual(f"Invalid type for value '{priority}': {type(priority)}",
+                         str(cm.exception))
diff --git a/tests/test_hub/test_add_external_rpm.py b/tests/test_hub/test_add_external_rpm.py
index 7aa928b..e36f808 100644
--- a/tests/test_hub/test_add_external_rpm.py
+++ b/tests/test_hub/test_add_external_rpm.py
@@ -20,20 +20,20 @@ class TestAddExternalRPM(unittest.TestCase):
         self.nextval = mock.patch('kojihub.nextval').start()
         self.Savepoint = mock.patch('kojihub.Savepoint').start()
         self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
-                side_effect=self.getInsert).start()
+                                          side_effect=self.getInsert).start()
         self.inserts = []
         self.insert_execute = mock.MagicMock()
 
         self.rpminfo = {
-                'name': 'NAME',
-                'version': 'VERSION',
-                'release': 'RELEASE',
-                'epoch': None,
-                'arch': 'noarch',
-                'payloadhash': 'fakehash',
-                'size': 42,
-                'buildtime': 0,
-                }
+            'name': 'NAME',
+            'version': 'VERSION',
+            'release': 'RELEASE',
+            'epoch': None,
+            'arch': 'noarch',
+            'payloadhash': 'fakehash',
+            'size': 42,
+            'buildtime': 0,
+        }
         self.repo = 'myrepo'
 
     def tearDown(self):
@@ -63,8 +63,9 @@ class TestAddExternalRPM(unittest.TestCase):
         rpminfo = self.rpminfo.copy()
         del rpminfo['size']
 
-        with self.assertRaises(koji.GenericError):
+        with self.assertRaises(koji.GenericError) as ex:
             kojihub.add_external_rpm(rpminfo, self.repo)
+        self.assertEqual(f"size field missing: {rpminfo}", str(ex.exception))
 
         self.get_rpm.assert_not_called()
         self.nextval.assert_not_called()
@@ -73,8 +74,10 @@ class TestAddExternalRPM(unittest.TestCase):
         rpminfo = self.rpminfo.copy()
         rpminfo['size'] = ['invalid type']
 
-        with self.assertRaises(koji.GenericError):
+        with self.assertRaises(koji.GenericError) as ex:
             kojihub.add_external_rpm(rpminfo, self.repo)
+        self.assertEqual(f"Invalid value for size: {rpminfo['size']}",
+                         str(ex.exception))
 
         self.get_rpm.assert_not_called()
         self.nextval.assert_not_called()
@@ -88,8 +91,11 @@ class TestAddExternalRPM(unittest.TestCase):
         self.get_external_repo_id.return_value = mock.sentinel.repo_id
 
         # call it (default is strict)
-        with self.assertRaises(koji.GenericError):
+        nvra = "%(name)s-%(version)s-%(release)s.%(arch)s" % self.rpminfo
+        disp = f"{nvra}@{self.repo}"
+        with self.assertRaises(koji.GenericError) as ex:
             kojihub.add_external_rpm(self.rpminfo, self.repo)
+        self.assertEqual(f"external rpm already exists: {disp}", str(ex.exception))
 
         self.assertEqual(len(self.inserts), 0)
         self.nextval.assert_not_called()
@@ -103,8 +109,12 @@ class TestAddExternalRPM(unittest.TestCase):
 
         # different hash
         prev['payloadhash'] = 'different hash'
-        with self.assertRaises(koji.GenericError):
+        nvra = "%(name)s-%(version)s-%(release)s.%(arch)s" % self.rpminfo
+        disp = f"{nvra}@{self.repo}"
+        with self.assertRaises(koji.GenericError) as ex:
             kojihub.add_external_rpm(self.rpminfo, self.repo, strict=False)
+        self.assertEqual(f"hash changed for external rpm: {disp} (different hash -> fakehash)",
+                         str(ex.exception))
 
         self.assertEqual(len(self.inserts), 0)
         self.nextval.assert_not_called()
@@ -118,8 +128,11 @@ class TestAddExternalRPM(unittest.TestCase):
         self.insert_execute.side_effect = FakeException('insert failed')
 
         # call it (default is strict)
-        with self.assertRaises(koji.GenericError):
+        nvra = "%(name)s-%(version)s-%(release)s.%(arch)s" % self.rpminfo
+        disp = f"{nvra}@{self.repo}"
+        with self.assertRaises(koji.GenericError) as ex:
             kojihub.add_external_rpm(self.rpminfo, self.repo)
+        self.assertEqual(f"external rpm already exists: {disp}", str(ex.exception))
 
         self.assertEqual(len(self.inserts), 1)
         self.nextval.assert_called_once()
@@ -139,8 +152,12 @@ class TestAddExternalRPM(unittest.TestCase):
         self.nextval.reset_mock()
         self.get_rpm.side_effect = [None, prev]
         prev['payloadhash'] = 'different hash'
-        with self.assertRaises(koji.GenericError):
+        nvra = "%(name)s-%(version)s-%(release)s.%(arch)s" % self.rpminfo
+        disp = f"{nvra}@{self.repo}"
+        with self.assertRaises(koji.GenericError) as ex:
             kojihub.add_external_rpm(self.rpminfo, self.repo, strict=False)
+        self.assertEqual(f"hash changed for external rpm: {disp} (different hash -> fakehash)",
+                         str(ex.exception))
 
         self.assertEqual(len(self.inserts), 1)
         self.nextval.assert_called_once()
@@ -149,10 +166,9 @@ class TestAddExternalRPM(unittest.TestCase):
         self.inserts[:] = []
         self.nextval.reset_mock()
         self.get_rpm.side_effect = [None, None]
-        with self.assertRaises(FakeException):
+        with self.assertRaises(FakeException) as ex:
             kojihub.add_external_rpm(self.rpminfo, self.repo, strict=False)
+        self.assertEqual('insert failed', str(ex.exception))
 
         self.assertEqual(len(self.inserts), 1)
         self.nextval.assert_called_once()
-
-
diff --git a/tests/test_hub/test_add_host.py b/tests/test_hub/test_add_host.py
index 93a0ae5..0592d1f 100644
--- a/tests/test_hub/test_add_host.py
+++ b/tests/test_hub/test_add_host.py
@@ -36,32 +36,31 @@ class TestAddHost(unittest.TestCase):
         self.context.session.assertPerm = mock.MagicMock()
         self.context.opts = {'HostPrincipalFormat': '-%s-'}
         self.exports = kojihub.RootExports()
+        self.verify_host_name = mock.patch('kojihub.verify_host_name').start()
+        self.verify_name_user = mock.patch('kojihub.verify_name_user').start()
+        self._dml = mock.patch('kojihub._dml').start()
+        self.get_host = mock.patch('kojihub.get_host').start()
+        self._singleValue = mock.patch('kojihub._singleValue').start()
+        self.get_user = mock.patch('kojihub.get_user').start()
 
     def tearDown(self):
         mock.patch.stopall()
 
-    @mock.patch('kojihub.verify_host_name')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub.get_host')
-    @mock.patch('kojihub._singleValue')
-    def test_add_host_exists(self, _singleValue, get_host, _dml, verify_host_name):
-        verify_host_name.return_value = None
-        get_host.return_value = {'id': 123}
+    def test_add_host_exists(self):
+        self.verify_host_name.return_value = None
+        self.get_host.return_value = {'id': 123}
         with self.assertRaises(koji.GenericError):
             self.exports.addHost('hostname', ['i386', 'x86_64'])
-        _dml.assert_not_called()
-        get_host.assert_called_once_with('hostname')
-        _singleValue.assert_not_called()
-
-    @mock.patch('kojihub.verify_host_name')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub.get_host')
-    @mock.patch('kojihub._singleValue')
-    def test_add_host_valid(self, _singleValue, get_host, _dml, verify_host_name):
-        verify_host_name.return_value = None
-        get_host.return_value = {}
-        _singleValue.side_effect = [333, 12]
+        self._dml.assert_not_called()
+        self.get_host.assert_called_once_with('hostname')
+        self._singleValue.assert_not_called()
+
+    def test_add_host_valid(self):
+        self.verify_host_name.return_value = None
+        self.get_host.return_value = {}
+        self._singleValue.side_effect = [333, 12]
         self.context.session.createUser.return_value = 456
+        self.get_user.return_value = None
 
         r = self.exports.addHost('hostname', ['i386', 'x86_64'])
         self.assertEqual(r, 12)
@@ -70,59 +69,48 @@ class TestAddHost(unittest.TestCase):
         kojihub.get_host.assert_called_once_with('hostname')
         self.context.session.createUser.assert_called_once_with(
             'hostname', usertype=koji.USERTYPES['HOST'], krb_principal='-hostname-')
-        self.assertEqual(_singleValue.call_count, 2)
-        _singleValue.assert_has_calls([
+        self.assertEqual(self._singleValue.call_count, 2)
+        self._singleValue.assert_has_calls([
             mock.call("SELECT id FROM channels WHERE name = 'default'"),
             mock.call("SELECT nextval('host_id_seq')", strict=True)
         ])
-        self.assertEqual(_dml.call_count, 1)
-        _dml.assert_called_once_with("INSERT INTO host (id, user_id, name) "
-                                     "VALUES (%(hostID)i, %(userID)i, %(hostname)s)",
-                                     {'hostID': 12, 'userID': 456, 'hostname': 'hostname'})
-
-    @mock.patch('kojihub.verify_host_name')
-    @mock.patch('kojihub.get_user')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub.get_host')
-    @mock.patch('kojihub._singleValue')
-    def test_add_host_wrong_user(self, _singleValue, get_host, _dml, get_user, verify_host_name):
-        verify_host_name.return_value = None
-        get_user.return_value = {
+        self.assertEqual(self._dml.call_count, 1)
+        self._dml.assert_called_once_with("INSERT INTO host (id, user_id, name) "
+                                          "VALUES (%(hostID)i, %(userID)i, %(hostname)s)",
+                                          {'hostID': 12, 'userID': 456, 'hostname': 'hostname'})
+
+    def test_add_host_wrong_user(self):
+        self.verify_host_name.return_value = None
+        self.get_user.return_value = {
             'id': 1,
             'name': 'hostname',
             'usertype': koji.USERTYPES['NORMAL']
         }
-        get_host.return_value = {}
+        self.get_host.return_value = {}
         with self.assertRaises(koji.GenericError):
             self.exports.addHost('hostname', ['i386', 'x86_64'])
-        _dml.assert_not_called()
-        get_user.assert_called_once_with(userInfo={'name': 'hostname'})
-        get_host.assert_called_once_with('hostname')
-        _singleValue.assert_called_once()
+        self._dml.assert_not_called()
+        self.get_user.assert_called_once_with(userInfo={'name': 'hostname'})
+        self.get_host.assert_called_once_with('hostname')
+        self._singleValue.assert_called_once()
         self.assertEqual(len(self.inserts), 0)
         self.assertEqual(len(self.updates), 0)
 
-    @mock.patch('kojihub.verify_host_name')
-    @mock.patch('kojihub.get_user')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub.get_host')
-    @mock.patch('kojihub._singleValue')
-    def test_add_host_wrong_user_forced(self, _singleValue, get_host, _dml, get_user,
-                                        verify_host_name):
-        verify_host_name.return_value = None
-        get_user.return_value = {
+    def test_add_host_wrong_user_forced(self):
+        self.verify_host_name.return_value = None
+        self.get_user.return_value = {
             'id': 123,
             'name': 'hostname',
             'usertype': koji.USERTYPES['NORMAL']
         }
-        get_host.return_value = {}
+        self.get_host.return_value = {}
 
         self.exports.addHost('hostname', ['i386', 'x86_64'], force=True)
 
-        _dml.assert_called_once()
-        get_user.assert_called_once_with(userInfo={'name': 'hostname'})
-        get_host.assert_called_once_with('hostname')
-        _singleValue.assert_called()
+        self._dml.assert_called_once()
+        self.get_user.assert_called_once_with(userInfo={'name': 'hostname'})
+        self.get_host.assert_called_once_with('hostname')
+        self._singleValue.assert_called()
         self.assertEqual(len(self.inserts), 2)
         self.assertEqual(len(self.updates), 1)
         update = self.updates[0]
@@ -131,40 +119,50 @@ class TestAddHost(unittest.TestCase):
         self.assertEqual(update.clauses, ['id = %(userID)i'])
         self.assertEqual(update.data, {'usertype': koji.USERTYPES['HOST']})
 
-    @mock.patch('kojihub.verify_host_name')
-    @mock.patch('kojihub.get_user')
-    @mock.patch('kojihub._dml')
-    @mock.patch('kojihub.get_host')
-    @mock.patch('kojihub._singleValue')
-    def test_add_host_superwrong_user_forced(self, _singleValue, get_host, _dml, get_user,
-                                             verify_host_name):
-        verify_host_name.return_value = None
-        get_user.return_value = {
+    def test_add_host_superwrong_user_forced(self):
+        self.verify_host_name.return_value = None
+        self.get_user.return_value = {
             'id': 123,
             'name': 'hostname',
             'usertype': koji.USERTYPES['GROUP']
         }
-        get_host.return_value = {}
+        self.get_host.return_value = {}
 
         with self.assertRaises(koji.GenericError):
             self.exports.addHost('hostname', ['i386', 'x86_64'], force=True)
 
-        _dml.assert_not_called()
-        get_user.assert_called_once_with(userInfo={'name': 'hostname'})
-        get_host.assert_called_once_with('hostname')
-        _singleValue.assert_called()
+        self._dml.assert_not_called()
+        self.get_user.assert_called_once_with(userInfo={'name': 'hostname'})
+        self.get_host.assert_called_once_with('hostname')
+        self._singleValue.assert_called()
         self.assertEqual(len(self.inserts), 0)
         self.assertEqual(len(self.updates), 0)
 
-    @mock.patch('kojihub.verify_host_name')
-    def test_add_host_wrong_format(self, verify_host_name):
+    def test_add_host_wrong_format(self):
         # name is longer as expected
         hostname = 'host-name+'
-        verify_host_name.side_effect = koji.GenericError
+        self.verify_host_name.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             self.exports.addHost(hostname, ['i386', 'x86_64'], force=True)
 
         # not except regex rules
-        verify_host_name.side_effect = koji.GenericError
+        self.verify_host_name.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             self.exports.addHost(hostname, ['i386', 'x86_64'], force=True)
+
+    def test_add_host_krbprincipal_wrong_type(self):
+        krb_principal = ['test-krb']
+        self.verify_host_name.return_value = None
+        self.get_host.return_value = {}
+        self._singleValue.side_effect = [333, 12]
+        self.verify_name_user.side_effect = koji.GenericError
+        with self.assertRaises(koji.GenericError):
+            self.exports.addHost('hostname', ['i386', 'x86_64'], krb_principal=krb_principal)
+
+        self.context.session.assertPerm.assert_called_once_with('host')
+        kojihub.get_host.assert_called_once_with('hostname')
+        self.context.session.createUser.assert_not_called()
+        self.assertEqual(self._singleValue.call_count, 1)
+        self._singleValue.assert_called_once_with("SELECT id FROM channels WHERE name = 'default'")
+        self.verify_host_name.assert_called_once_with('hostname')
+        self.verify_name_user.assert_called_once_with(krb=krb_principal)
diff --git a/tests/test_hub/test_add_user_krb_principal.py b/tests/test_hub/test_add_user_krb_principal.py
new file mode 100644
index 0000000..dcaeee5
--- /dev/null
+++ b/tests/test_hub/test_add_user_krb_principal.py
@@ -0,0 +1,42 @@
+import mock
+import unittest
+import koji
+import kojihub
+import copy
+
+
+class TestAddUserKrbPrincipal(unittest.TestCase):
+
+    def setUp(self):
+        self.get_user = mock.patch('kojihub.get_user').start()
+        self.verify_name_user = mock.patch('kojihub.verify_name_user').start()
+        self.get_user_by_krb_principal = mock.patch('kojihub.get_user_by_krb_principal').start()
+        self.username = 'testuser'
+        self.krbprincipal = '%s@TEST.COM' % self.username
+        self.userinfo = {'id': 1, 'name': self.username}
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_non_exist_user(self):
+        self.get_user.side_effect = koji.GenericError
+        with self.assertRaises(koji.GenericError):
+            kojihub.RootExports().addUserKrbPrincipal(self.username, self.krbprincipal)
+
+    def test_wrong_krbprincipal_format(self):
+        krbprincipal = 'test-krbprincipal+'
+        self.get_user.return_value = self.userinfo
+        self.verify_name_user.side_effect = koji.GenericError
+        with self.assertRaises(koji.GenericError):
+            kojihub.RootExports().addUserKrbPrincipal(self.username, krbprincipal)
+
+    def test_existing_krb(self):
+        userinfo = copy.deepcopy(self.userinfo)
+        userinfo['krb_principal'] = self.krbprincipal
+        self.get_user.return_value = self.userinfo
+        self.verify_name_user.return_value = None
+        self.get_user_by_krb_principal.return_value = userinfo
+        with self.assertRaises(koji.GenericError) as ex:
+            kojihub.RootExports().addUserKrbPrincipal(self.username, self.krbprincipal)
+        self.assertEqual('user with this Kerberos principal already exists: %s'
+                         % self.krbprincipal, str(ex.exception))
diff --git a/tests/test_hub/test_build.py b/tests/test_hub/test_build.py
new file mode 100644
index 0000000..e2c7382
--- /dev/null
+++ b/tests/test_hub/test_build.py
@@ -0,0 +1,40 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestBuild(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertLogin = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self.make_task = mock.patch('kojihub.make_task').start()
+        self.src = 'test-src'
+        self.target = 'test-target'
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_src_wrong_type(self):
+        src = ['test-priority']
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.build(src, self.target)
+        self.assertEqual(f"Invalid type for value '{src}': {type(src)}", str(cm.exception))
+
+    def test_priority_without_admin(self):
+        priority = -10
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.build(self.src, self.target, priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_channel_not_str(self):
+        priority = 10
+        self.get_channel.return_value = {'comment': None, 'description': None, 'enabled': True,
+                                         'id': 2, 'name': 'maven'}
+        self.make_task.return_value = 123
+        self.exports.build(self.src, self.target, priority=priority, channel=2)
